#pragma once

#include <string>
#include <queue>
#include <vector>
#include <thread>
#include <mutex>
#include <condition_variable>

class TaskManager {
public:
    typedef std::string Job;
    TaskManager();
    ~TaskManager();

    void start();
    void stop();
    void wait();
    bool busy();

private:
    void loop();

private:
    bool running;
    bool stopping;
    uint32_t maxThreads;
    uint32_t activeThreads;
    std::queue<Job> queue;
    std::mutex queueMutex;
    std::condition_variable loopConditional;
    std::condition_variable waitConditional;
    std::vector<std::thread> threads;
};
